From 82a44df157b02f45fe36575ab69b780c88e799b6 Mon Sep 17 00:00:00 2001
From: Xavier Lacot <xavier@lacot.org>
Date: Thu, 15 Mar 2012 15:28:15 +0100
Subject: [PATCH] added support for transactions, for faster mass inserts

---
 joli.js | 21 +++++++++++++++++++++
 1 file changed, 21 insertions(+)

diff --git a/joli.js b/joli.js
index c177621..1f7e7cf 100644
--- a/joli.js
+++ b/joli.js
@@ -802,6 +802,27 @@ joli.record.prototype = {
     }
 };
 
+joli.transaction = function(name) {
+    this.data = {
+        commited: false
+    };
+};
+
+joli.transaction.prototype = {
+    begin: function() {
+        joli.connection.execute('BEGIN;');
+    },
+
+    commit: function() {
+        if (this.data.commited) {
+            throw new Error('The transaction was already commited!');        
+        }
+
+        joli.connection.execute('COMMIT;');  
+        this.data.commited = true;      
+    },
+};
+
 /**
  * In case joli.js is loaded as a CommonJS module
  */
